local mod = ...


mod:override({
    Id = "DEFAULT_BALANCING",
    StartingTileResourceRequirement = {
        {
            Resource = "BERRIES",
            Quantity = 1
        },
        {
            Resource = "STONE",
            Quantity = 1
        },
        {
            Resource = "WOOD",
            Quantity = 5
        },
    }
})



-- -- Assets -------------------------------------------------------------------------------------
-- mod:registerAssetId("models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", "PREFAB_STEPPE_TREE1")



-- -- Plantable -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 5.0 })
-- mod:registerPrefabComponent("models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", { DataType = "COMP_TREE" })

-- mod:register({
--     DataType = "PLANTABLE",
--     Id = "PLANTABLE_STEPPE_TREE1",
--     Name = "PLANTABLE_STEPPE_TREE1_NAME",
--     PlantPrefab = "PREFAB_STEPPE_TREE1",
--     MinimumScale = 0.85, -- min size at full growth
--     MaximumScale = 1.15 -- max size at full growth
-- })



-- -- Resource Container -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent( "models/CattleHerd1.fbx/Prefab/TreePart1/Tree.001", {
--     DataType = "COMP_RESOURCE_CONTAINER",
--     ResourceData = "WOOD",
--     IsReplenishable = false,
--     ResourceValue = 1.0, -- how many are gathered with each pick
--     AvailableQuantity = 1, -- maximum container stock
--     Radius = 0.85, -- distance from container that the villager will stand to pick
--     IsDestroyWhenEmpty = true,
--     HasMaximumWorkstation = false
-- })



-- registering map files
mod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mod:registerAssetId("maps/berries.png", "BERRIES_DENSITY_MAP")
mod:registerAssetId("maps/stone.png", "ROCK_DENSITY_MAP")
mod:registerAssetId("maps/tree.png", "TREE_DENSITY_MAP")
mod:registerAssetId("maps/milk.png", "MILK_DENSITY_MAP")



-- register custom map
mod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_KARABULAK",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -10,
	MaxHeight = 90,
	VillagePathList = {
		{
			Entrance = { 100, 0, 1013 },
			Exit = { 100, 0, 13 },
		},
		{
			Entrance = { 200, 0, 1013 },
			Exit = { 200, 0, 13 },
		},
		{
			Entrance = { 300, 0, 1013 },
			Exit = { 300, 0, 13 },
		},
		{
			Entrance = { 400, 0, 1013 },
			Exit = { 400, 0, 13 },
		},
		{
			Entrance = { 500, 0, 1013 },
			Exit = { 500, 0, 13 },
		},
		{
			Entrance = { 600, 0, 1013 },
			Exit = { 600, 0, 13 },
		},
		{
			Entrance = { 700, 0, 1013 },
			Exit = { 700, 0, 13 },
		},
		{
			Entrance = { 800, 0, 1013 },
			Exit = { 800, 0, 13 },
		},
		{
			Entrance = { 900, 0, 1013 },
			Exit = { 900, 0, 13 },
		}
	},
	SpawnList = {
		-- {
		-- 	Prefab = "PREFAB_MINERAL_WATER",
		-- 	Position = { 675 , 60 , 295 },
		-- 	Orientation = { 0.0, -175.0 , 0.0},
		-- 	PatchBeforeVersion = "1.1.0"
		-- },
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 475 , 41 , 795 },
			Orientation = { 0.0, -175.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 402 , 44 , 190 },
			Orientation = { 0.0, 90.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 513 , 53 , 112 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 584 , 49 , 192 },
			Orientation = { 0.0, -60.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 711 , 33 , 169 },
			Orientation = { 0.0, 60.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 633 , 27 , 826 },
			Orientation = { 0.0, 170.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 819 , 23 , 850 },
			Orientation = { 0.0, 120.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 859 , 39 , 73 },
			Orientation = { 0.0, 70.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 420 , 38 , 788 },
			Orientation = { 0.0, 160.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		}
	},
	DensitySpawnList = {
        {
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP",
			Density = 0.01,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 2.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				-- {
                --     PrefabList = { "PREFAB_LIVESTOCK_COW" },
                --     RandomWeight = 1.0,
                --     OffsetSizeRange = {
                --         Min = 0,
                --         Max = 0
                -- },
                --     OrientationRange = {
                --         Min = { 0, -180, 0 },
                --         Max = { 0, 180, 0 }
                -- },
                --     ScaleRange = {
                --         Min = 1.7,
                --         Max = 1.7
                -- },
                --     ColorRange = {
                --         Min = { 0.8,0.8,0.8,1 },
                --         Max = { 1,1,1,1 }
                -- }
            }
        },
        
        {
			DensityMap = "MILK_DENSITY_MAP",
			Density = 0.05,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_LIVESTOCK_COW" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 1.0,
                        Max = 1.0
                },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                },
                    ScaleRange = {
                        Min = 1.3,
                        Max = 1.3
                },
                    ColorRange = {
                        Min = { 0.8,0.8,0.8,1 },
                        Max = { 1,1,1,1 }
                }
            }
        }
		},

		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.2,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},

        {
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.2,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
        },
    }
	-- 	{
	-- 		-- Create fish shoals
	-- 		DensityMap = "FISH_DENSITY_MAP",
	-- 		Density =0.9,
	-- 		PrefabConfigList = {
	-- 			{
	-- 					PrefabList = { "PREFAB_RESOURCE_FISH" },
	-- 					RandomWeight = 0.1,
	-- 					OffsetSizeRange = {
	-- 						Min = 0.75,
	-- 						Max = 1.0
	-- 				},
	-- 					OrientationRange = {
	-- 						Min = { 0, -180, 0 },
	-- 						Max = { 0, 180, 0 }
	-- 				},
	-- 					ScaleRange = {
	-- 						Min = 0.85,
	-- 						Max = 1.15
	-- 				},
	-- 					ColorRange = {
	-- 						Min = { 0.8, 0.8, 0.8, 1 },
	-- 						Max = { 1, 1, 1, 1 }
	-- 				}
	-- 			}
	-- 		}
	-- 	}
	-- }
})



-- This map was created with the help of the UFME
